//index.js
//获取应用实例
const app = getApp()
import fetch from '../../../utils/http'
const $api = require('../../../config/api.js').$api;

Component({
  behaviors: [],
  properties: {},
  banner: [],
  data: {
    UserInfo: app.globalData.UserInfo,
    TopNavList: [{
      value: '楼盘展示',
      icon: '/assets/images/icon5.png',
      remark: '银城在售全部楼盘'
    }, {
      value: '购房工具',
      icon: '/assets/images/icon6.png',
      remark: '查公积金、算房贷、看政策'
    }, {
      value: '电话咨询',
      icon: '/assets/images/icon7.png',
      remark: '客服热线：025-86505555'
    }],
    EstateList: []
  },
  lifetimes: {},
  ready: function() {
    wx.setNavigationBarTitle({
      title: '银城地产·江北公司'
    })
    const _that = this
    fetch({
      url: $api.banner.list.url,
      method: $api.banner.list.method,
      data: {
        imgLocation: 'firstPage'
      }
    }).then((imgs) => {
      _that.setData({
        banner: imgs.data
      })
    })

    wx.getSetting({
      success(res) {
        if (!res.authSetting['scope.userLocation']) {
          wx.authorize({
            scope: 'scope.userLocation',
            success() {
              _that.GetBuildingList()
            }
          })
        } else {
          _that.GetBuildingList()
        }
      }
    })
  },
  pageLifetimes: {
    show: function() {},
  },
  methods: {
    GetBuildingList() {
      const _that = this
      wx.getLocation({
        type: 'wgs84',
        success(res) {
          fetch({
            url: $api.building.mainlist.url,
            method: $api.building.mainlist.method,
            data: {
              pageNum: 1,
              pageSize: 10
            }
          }).then((buildings) => {
            const records = buildings.data.map(x => {
              const distance = parseInt(_that.GetGreatCircleDistance(res.latitude, res.longitude, x.coordinate.split(',')[0], x.coordinate.split(',')[1] || res.longitude))
              return {
                ...x,
                distance: distance / 10
              }
            })
            _that.setData({
              EstateList: records
            })
          })
        }})
    },
    GetGreatCircleDistance(lat1, lng1, lat2, lng2) {
      if (lat1 === lat2 && lng1 === lng2) {
        return 0
      }
      var EARTH_RADIUS = 6378137.0//单位M
      var PI = Math.PI
      var radLat1 = lat1 * PI / 180.0
      var radLat2 = lat2 * PI / 180.0
      var a = radLat1 - radLat2
      var b = lng1 * PI / 180.0 - lng2 * PI / 180.0
      var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)))
      s = s * EARTH_RADIUS
      s = Math.round(s * 10000) / 10000.0
      return s / 100
    },
    ItemTap(e) {
      wx.navigateTo({
        url: '/pages/EstateDetail/index?id=' + e.target.dataset.id
      })
    },
    TopNavTap(e) { // topnav点击事件
      if (e.target.dataset.type === 0) { // 楼盘展示
        this.triggerEvent('myevent', {
          index: 1
        })
      } else if (e.target.dataset.type === 1) { // 购房工具
        wx.navigateTo({
          url: '/pages/SelfServiceTool/index'
        })
      } else if (e.target.dataset.type === 2) { // 电话咨询
        wx.makePhoneCall({
          phoneNumber: '025-86505555'
        })
      }
    },
    toMap() {
      wx.navigateTo({
        url: '/pages/map/testmap',
      })
    },
    toBuildingShow() {
      this.triggerEvent('myevent', {
        index: 1
      })
    },
    toGf() {
      wx.navigateTo({
        url: '/pages/SelfServiceTool/index'
      })
    },
    toTel() {
      wx.makePhoneCall({
        phoneNumber: '025-86505555'
      })
    }
  }
})