import store from '../../store'
import create from '../../utils/create'
import fetch from '../../utils/http'
const $api = require('../../config/api.js').$api;

const app = getApp()

create(store, {
  onLoad(e) {
    this.setData({
      NavActiveIndex: e.index || 0
    })
    const _that = this
    fetch({
      url: $api.propaganda.list.url,
      method: $api.propaganda.list.method
    }).then((imgs) => {
      if(imgs.data.length>0) {
        _that.setData({
          ShowLayer: true,
          propagandaList: imgs.data
        })
      }
    })
  },
  data: {
    ShowLayer: false,
    propagandaList: [],
    NavList: [{ // navlist数据
      value: '首页',
      icon: '/assets/images/icon1.png'
    }, {
      value: '楼盘',
      icon: '/assets/images/icon2.png'
    }, {
      value: '福利',
      icon: '/assets/images/icon3.png'
    }, {
      value: '我的',
      icon: '/assets/images/icon4.png'
    }],
    ScreenBottomHeight: app.globalData.ScreenBottomHeight,
    NavActiveIndex: 0 // nav焦点索引值
  },
  TriggerCutNav(e) {
    this.DealNavCut(e.detail.index)
  },
  DealNavCut(index) {
    if (index === 0) {
      wx.setNavigationBarTitle({
        title: '银城地产·江北公司'
      })
    } else if (index === 1) {
      wx.setNavigationBarTitle({
        title: '银城地产·江北公司'
      })
    } else if (index === 2) {
      wx.setNavigationBarTitle({
        title: '楼盘资讯'
      })
    } else if (index === 3) {
      wx.setNavigationBarTitle({
        title: '我的'
      })
    }
    this.setData({
      NavActiveIndex: index
    })
  },
  CutNav(e) { // 切换Nav
    if (e.target.dataset.index !== undefined) {
      this.DealNavCut(e.target.dataset.index)
    }
  },
  onShareAppMessage: function () {
    return app.globalData.ShareDate
  },
  closeLayer() {
    this.setData({
      ShowLayer: false
    })
  },
  propagandaClick(e) {
    if (e.target.dataset.pro.skipType && e.target.dataset.pro.skipType == 'building' && e.target.dataset.pro.skipId != ''){
      wx.navigateTo({
        url: '/pages/EstateDetail/index?id=' + e.target.dataset.pro.skipId,
      })
    }
    if (e.target.dataset.pro.skipType && e.target.dataset.pro.skipType == 'activity' && e.target.dataset.pro.skipId != '') {
      wx.navigateTo({
        url: '/pages/ActivityDetail/index?type=2&id=' + e.target.dataset.pro.skipId,
      })
    }
  }
})