import store from '../store'
import fetch from '../utils/http'
import { get as getApi } from '../config/api'

function signUp(userInfo, app) {
  return new Promise((resolve, reject) => {
    const openid = store.data.userInfo.openid

    fetch({
      ...getApi('user.login'),
      data: {
        avatar: userInfo.avatarUrl,
        name: userInfo.nickName,
        openid: openid,
      }
    }).then(() => {
      // 更新 store
      store.data.userInfo.avatar = userInfo.avatarUrl
      store.data.userInfo.name = userInfo.nickName
      store.data.userInfo.hasReg = 1
      store.data.userInfo.activity = userInfo.activity
      store.data.userInfo.appointment = userInfo.appointment
      store.data.userInfo.collectionBuilding = userInfo.collectionBuilding
      store.update()
  
      // 更新 globalData
      app.globalData.UserInfo = store.data.userInfo

      resolve(store.data.userInfo)
    }).catch(err => reject(err))
  })
}

export default signUp
